import os

def do(cmdlist):
    cmd = ' '.join(cmdlist)
    print '$ %s' % cmd
    os.system(cmd)

def esri2geojson(url, outname):
    return do(['esri2geojson', '"%s"' % url, '"%s"' % outname])

def wget(url, outname):
    return do(['wget', '"%s"' % url, '--output-document="%s"' % outname])

def mkdirp(path):
    return do(['mkdir', '-p', path])


class Getter(object):

    def __init__(self, datadir):
        mkdirp(datadir)
        self.datadir = datadir

    def getMap(self, url, label):
        assert 'MapServer' in url
        wget(url, self.datadir+label+'.html')
        wget(url+'/kml/mapImage.kmz', self.datadir+label+'.kmz')

    def getFeatures(self, url, nlayers, label):
        assert 'FeatureServer' in url
        wget(url, self.datadir+label+'.html')
        for layer in range(nlayers):
            path = url+'/%d' % layer
            outfilebase = self.datadir+label+'-%d' % layer
            wget(path, outfilebase+'.html')
            esri2geojson(path, outfilebase+'.geojson')
    
    def get(self, url, nlayers, label):
        if 'MapServer' in url:
            self.getMap(url, label)
        else:
            self.getFeatures(url, nlayers, label)
